# To troubleshoot and get more log info enable ldap debug logging in grafana.ini
# [log]
# filters = ldap:debug

[[servers]]
# Ldap server host (specify multiple hosts space separated)
{% if 'ldap' in grafana and 'host' in grafana.ldap %}
host = "{{grafana.ldap['host']}}"
{% else %}
host = "127.0.0.1"
{% endif %}
# Default port is 389 or 636 if use_ssl = true
{% if 'ldap' in grafana and 'port' in grafana.ldap %}
port = "{{grafana.ldap['port']}}"
{% else %}
port = 389
{% endif %}
# Set to true if LDAP server should use an encrypted TLS connection (either with STARTTLS or LDAPS)
{% if 'ldap' in grafana and 'use_ssl' in grafana.ldap %}
use_ssl = "{{grafana.ldap['use_ssl']}}"
{% else %}
use_ssl = false
{% endif %}

# If set to true, use LDAP with STARTTLS instead of LDAPS
{% if 'ldap' in grafana and 'start_tls' in grafana.ldap %}
start_tls = "{{grafana.ldap['start_tls']}}"
{% else %}
start_tls = false
{% endif %}
# set to true if you want to skip ssl cert validation
{% if 'ldap' in grafana and 'ssl_skip_verify' in grafana.ldap %}
ssl_skip_verify = "{{grafana.ldap['ssl_skip_verify']}}"
{% else %}
ssl_skip_verify = false
{% endif %}
# set to the path to your root CA certificate or leave unset to use system defaults
{% if 'ldap' in grafana and 'root_ca_cert' in grafana.ldap %}
root_ca_cert = "{{grafana.ldap['root_ca_cert']}}"
{% else %}
# root_ca_cert = "/path/to/certificate.crt"
{% endif %}
# Authentication against LDAP servers requiring client certificates
{% if 'ldap' in grafana and 'client_cert' in grafana.ldap %}
client_cert = "{{grafana.ldap['client_cert']}}"
{% else %}
# client_cert = "/path/to/client.crt"
{% endif %}
{% if 'ldap' in grafana and 'client_key' in grafana.ldap %}
client_key = "{{grafana.ldap['client_key']}}"
{% else %}
# client_key = "/path/to/client.key"
{% endif %}

# Search user bind dn
{% if 'ldap' in grafana and 'bind_dn' in grafana.ldap %}
bind_dn = "{{grafana.ldap['bind_dn']}}"
{% else %}
bind_dn = "cn=admin,dc=grafana,dc=org"
{% endif %}
# Search user bind password
# If the password contains # or ; you have to wrap it with triple quotes. Ex """#password;"""
{% if 'ldap' in grafana and 'bind_password' in grafana.ldap %}
bind_password = '{{grafana.ldap["bind_password"]}}'
{% else %}
bind_password = 'grafana'
{% endif %}

# User search filter, for example "(cn=%s)" or "(sAMAccountName=%s)" or "(uid=%s)"
{% if 'ldap' in grafana and 'search_filter' in grafana.ldap %}
search_filter = "{{grafana.ldap['search_filter']}}"
{% else %}
search_filter = "(cn=%s)"
{% endif %}

# An array of base dns to search through
{% if 'ldap' in grafana and 'search_base_dns' in grafana.ldap %}
search_base_dns = ["{{grafana.ldap.search_base_dns |join('", "')}}"]
{% else %}
search_base_dns = ["dc=grafana,dc=org"]
{% endif %}

## For Posix or LDAP setups that does not support member_of attribute you can define the below settings
## Please check grafana LDAP docs for examples
{% if 'ldap' in grafana and 'group_search_filter' in grafana.ldap %}
group_search_filter = "{{grafana.ldap['group_search_filter']}}"
{% else %}
# group_search_filter = "(&(objectClass=posixGroup)(memberUid=%s))"
{% endif %}
{% if 'ldap' in grafana and 'group_search_base_dns' in grafana.ldap %}
group_search_base_dns = ["{{grafana.ldap.group_search_base_dns |join('", "')}}"]
{% else %}
# group_search_base_dns = ["ou=groups,dc=grafana,dc=org"]
{% endif %}
{% if 'ldap' in grafana and 'group_search_filter_user_attribute' in grafana.ldap %}
group_search_filter_user_attribute = "{{grafana.ldap['group_search_filter_user_attribute']}}"
{% else %}
# group_search_filter_user_attribute = "uid"
{% endif %}

# Specify names of the ldap attributes your ldap uses
{% if 'ldap' in grafana and 'servers' in grafana.ldap and 'attributes' in grafana.ldap.servers %}
[servers.attributes]
{% for attr in grafana.ldap.servers['attributes'] |dict2items %}
{{attr.key}} = "{{attr.value}}"
{% endfor %}
{% else %}
[servers.attributes]
name = "givenName"
surname = "sn"
username = "cn"
member_of = "memberOf"
email =  "email"
{% endif %}

{% if 'ldap' in grafana and 'servers' in grafana.ldap and 'group_mappings' in grafana.ldap.servers %}
{% for group in grafana.ldap.servers.group_mappings %}
[[servers.group_mappings]]
{% for mappings in group |dict2items %}
{# org_id должен быть без "" #}
{% if mappings.value is string %}
{{mappings.key}} = "{{mappings.value}}"
{% else %}
{{mappings.key}} = {{mappings.value}}
{% endif %}
{% endfor %}

{% endfor %}
{% else %}
# Map ldap groups to grafana org roles
[[servers.group_mappings]]
group_dn = "cn=admins,ou=groups,dc=grafana,dc=org"
org_role = "Admin"
# To make user an instance admin  (Grafana Admin) uncomment line below
# grafana_admin = true
# The Grafana organization database id, optional, if left out the default org (id 1) will be used
# org_id = 1

[[servers.group_mappings]]
group_dn = "cn=users,ou=groups,dc=grafana,dc=org"
org_role = "Editor"

[[servers.group_mappings]]
# If you want to match all (or no ldap groups) then you can use wildcard
group_dn = "*"
org_role = "Viewer"
{% endif %}